--- kern/uipc_socket.c	2006/02/12 15:00:33
+++ kern/uipc_socket.c	2006/02/21 23:55:13
@@ -1,6 +1,6 @@
 /*-
  * Copyright (c) 2004 The FreeBSD Foundation
- * Copyright (c) 2004-2005 Robert N. M. Watson
+ * Copyright (c) 2004-2006 Robert N. M. Watson
  * Copyright (c) 1982, 1986, 1988, 1990, 1993
  *	The Regents of the University of California.  All rights reserved.
  *
@@ -31,6 +31,40 @@
  *	@(#)uipc_socket.c	8.3 (Berkeley) 4/15/94
  */
 
+/*
+ * Comments on the socket life cycle:
+ *
+ * soalloc() sets of socket layer state for a socket, called only by
+ * socreate().  Socket layer private.
+ *
+ * pru_attach() associates protocol layer state with an allocated socket;
+ * called only once, may fail, aborting socket allocation.  This is called
+ * from socreate().
+ *
+ * pru_detach() disassociates protocol layer state with an attached socket;
+ * this will be called only once, to notify the protocol that the socket
+ * layer is done with the socket.  However, if the protocol has acquired a
+ * strong socket reference by setting SS_PROTOREF, the socket layer will not
+ * allow sofree() to release the socket.  Once a pru_detach() has been
+ * received while holding a strong reference, the protocol is responsible for
+ * later calling sofree() to release the socket.  This is useful for
+ * protocols in which need for socket buffer contents may continue after
+ * socket close, in which case the protocol can take ownership of the socket
+ * until it is ready to release it.
+ *
+ * sodealloc() tears down socket layer state for a socket, called only by
+ * sofree().  Socket layer private.
+ *
+ * socreate() creates a socket and attaches protocol state.
+ * sonewconn() creates a socket and attaches protocol state.
+ * sofree() destroys a socket and detaches protocol layer state.
+ *
+ * soclose() destroys a socket after waiting for it to disconnect.
+ * soabort() destroys a socket without waiting for it to disconnect (used
+ * only for incoming connections that are already connected).  Calls
+ * pru_detach().
+ */
+
 #include <sys/cdefs.h>
 __FBSDID("$FreeBSD: src/sys/kern/uipc_socket.c,v 1.257 2006/02/12 15:00:27 rwatson Exp $");
 
@@ -250,6 +284,8 @@
 {
 
 	KASSERT(so->so_count == 0, ("sodealloc(): so_count %d", so->so_count));
+	KASSERT(so->so_pcb == NULL, ("sodealloc(): so_pcb != NULL"));
+
 	mtx_lock(&so_global_mtx);
 	so->so_gencnt = ++so_gencnt;
 	mtx_unlock(&so_global_mtx);
@@ -328,13 +364,18 @@
 /*
  * Attempt to free a socket.  This should really be sotryfree().
  *
- * We free the socket if the protocol is no longer interested in the socket,
- * there's no file descriptor reference, and the refcount is 0.  While the
- * calling macro sotryfree() tests the refcount, sofree() has to test it
- * again as it's possible to race with an accept()ing thread if the socket is
- * in an listen queue of a listen socket, as being in the listen queue
- * doesn't elevate the reference count.  sofree() acquires the accept mutex
- * early for this test in order to avoid that race.
+ * sofree() will succeed if:
+ *
+ * - There are no outstanding file descriptor references or related consumers
+ *   (so_count == 0).
+ *
+ * - The socket has been closed by user space, if ever open (SS_NOFDREF).
+ *
+ * - The protocol does not have an outstanding strong reference on the socket
+ *   (SS_PROTOREF).
+ *
+ * Otherwise, it will quietly abort so that a future call to sofree(), when
+ * conditions are right, can succeed.
  */
 void
 sofree(so)
@@ -345,8 +386,8 @@
 	ACCEPT_LOCK_ASSERT();
 	SOCK_LOCK_ASSERT(so);
 
-	if (so->so_pcb != NULL || (so->so_state & SS_NOFDREF) == 0 ||
-	    so->so_count != 0) {
+	if ((so->so_state & SS_NOFDREF) == 0 || so->so_count != 0 ||
+	    (so->so_state & SS_PROTOREF)) {
 		SOCK_UNLOCK(so);
 		ACCEPT_UNLOCK();
 		return;
@@ -388,6 +429,7 @@
 	    so->so_qstate & SQ_COMP, so->so_qstate & SQ_INCOMP));
 	SOCK_UNLOCK(so);
 	ACCEPT_UNLOCK();
+
 	SOCKBUF_LOCK(&so->so_snd);
 	so->so_snd.sb_flags |= SB_NOINTR;
 	(void)sblock(&so->so_snd, M_WAITOK);
@@ -448,8 +490,6 @@
 		}
 		ACCEPT_UNLOCK();
 	}
-	if (so->so_pcb == NULL)
-		goto discard;
 	if (so->so_state & SS_ISCONNECTED) {
 		if ((so->so_state & SS_ISDISCONNECTING) == 0) {
 			error = sodisconnect(so);
@@ -468,13 +508,9 @@
 			}
 		}
 	}
+
 drop:
-	if (so->so_pcb != NULL) {
-		int error2 = (*so->so_proto->pr_usrreqs->pru_detach)(so);
-		if (error == 0)
-			error = error2;
-	}
-discard:
+	(*so->so_proto->pr_usrreqs->pru_detach)(so);
 	ACCEPT_LOCK();
 	SOCK_LOCK(so);
 	KASSERT((so->so_state & SS_NOFDREF) == 0, ("soclose: NOFDREF"));
@@ -488,21 +524,26 @@
  * into the protocol, which will call back into the socket code causing
  * it to acquire additional socket locks that may cause recursion or lock
  * order reversals.
+ *
+ * soabort() is used to abort a received but unaccepted connection, as
+ * it doesn't have any valid references yet.
+ *
+ * XXXRW: Why do we maintain a distinction between pru_abort() and
+ * pru_detach()?
+ *
+ * XXXRW: Right now we don't attempt to handle SS_PROTOREF here.
  */
-int
+void
 soabort(so)
 	struct socket *so;
 {
-	int error;
+
+	KASSERT(so->so_count == 0, ("soabort: so_count"));
 
-	error = (*so->so_proto->pr_usrreqs->pru_abort)(so);
-	if (error) {
-		ACCEPT_LOCK();
-		SOCK_LOCK(so);
-		sotryfree(so);	/* note: does not decrement the ref count */
-		return (error);
-	}
-	return (0);
+	(*so->so_proto->pr_usrreqs->pru_abort)(so);
+	ACCEPT_LOCK();
+	SOCK_LOCK(so);
+	sofree(so);
 }
 
 int
@@ -1527,7 +1568,7 @@
 			 * Notify the protocol that some data has been
 			 * drained before blocking.
 			 */
-			if (pr->pr_flags & PR_WANTRCVD && so->so_pcb != NULL) {
+			if (pr->pr_flags & PR_WANTRCVD) {
 				SOCKBUF_UNLOCK(&so->so_rcv);
 				(*pr->pr_usrreqs->pru_rcvd)(so, flags);
 				SOCKBUF_LOCK(&so->so_rcv);
@@ -1571,7 +1612,7 @@
 		 * ACK will be generated on return to TCP.
 		 */
 		if (!(flags & MSG_SOCALLBCK) && 
-		    (pr->pr_flags & PR_WANTRCVD) && so->so_pcb) {
+		    (pr->pr_flags & PR_WANTRCVD)) {
 			SOCKBUF_UNLOCK(&so->so_rcv);
 			(*pr->pr_usrreqs->pru_rcvd)(so, flags);
 			SOCKBUF_LOCK(&so->so_rcv);
--- kern/uipc_socket2.c	2005/11/22 01:56:03
+++ kern/uipc_socket2.c	2006/02/13 21:54:01
@@ -1282,10 +1282,10 @@
  * Some routines that return EOPNOTSUPP for entry points that are not
  * supported by a protocol.  Fill in as needed.
  */
-int
+void
 pru_abort_notsupp(struct socket *so)
 {
-	return EOPNOTSUPP;
+
 }
 
 int
@@ -1325,10 +1325,10 @@
 	return EOPNOTSUPP;
 }
 
-int
+void
 pru_detach_notsupp(struct socket *so)
 {
-	return EOPNOTSUPP;
+
 }
 
 int
--- kern/uipc_usrreq.c	2006/01/30 08:24:26
+++ kern/uipc_usrreq.c	2006/02/13 21:54:59
@@ -1,7 +1,7 @@
 /*-
  * Copyright (c) 1982, 1986, 1989, 1991, 1993
  *	The Regents of the University of California.
- * Copyright 2004-2005 Robert N. M. Watson
+ * Copyright 2004-2006 Robert N. M. Watson
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -139,24 +139,17 @@
 static int     unp_listen(struct socket *, struct unpcb *, int,
 		   struct thread *);
 
-static int
+static void
 uipc_abort(struct socket *so)
 {
 	struct unpcb *unp;
 
+	unp = sotounpcb(so);
+	KASSERT(unp != NULL, ("uipc_abort: unp == NULL"));
 	UNP_LOCK();
-	unp = sotounpcb(so);
-	if (unp == NULL) {
-		UNP_UNLOCK();
-		return (EINVAL);
-	}
 	unp_drop(unp, ECONNABORTED);
 	unp_detach(unp);
 	UNP_UNLOCK_ASSERT();
-	ACCEPT_LOCK();
-	SOCK_LOCK(so);
-	sotryfree(so);
-	return (0);
 }
 
 static int
@@ -170,15 +163,10 @@
 	 * if it was bound and we are still connected
 	 * (our peer may have closed already!).
 	 */
+	unp = sotounpcb(so);
+	KASSERT(unp != NULL, ("uipc_accept: unp == NULL"));
 	*nam = malloc(sizeof(struct sockaddr_un), M_SONAME, M_WAITOK);
 	UNP_LOCK();
-	unp = sotounpcb(so);
-	if (unp == NULL) {
-		UNP_UNLOCK();
-		free(*nam, M_SONAME);
-		*nam = NULL;
-		return (EINVAL);
-	}
 	if (unp->unp_conn != NULL && unp->unp_conn->unp_addr != NULL)
 		sa = (struct sockaddr *) unp->unp_conn->unp_addr;
 	else
@@ -191,10 +179,7 @@
 static int
 uipc_attach(struct socket *so, int proto, struct thread *td)
 {
-	struct unpcb *unp = sotounpcb(so);
 
-	if (unp != NULL)
-		return (EISCONN);
 	return (unp_attach(so));
 }
 
@@ -204,12 +189,9 @@
 	struct unpcb *unp;
 	int error;
 
+	unp = sotounpcb(so);
+	KASSERT(unp != NULL, ("uipc_bind: unp == NULL"));
 	UNP_LOCK();
-	unp = sotounpcb(so);
-	if (unp == NULL) {
-		UNP_UNLOCK();
-		return (EINVAL);
-	}
 	error = unp_bind(unp, nam, td);
 	UNP_UNLOCK();
 	return (error);
@@ -223,12 +205,9 @@
 
 	KASSERT(td == curthread, ("uipc_connect: td != curthread"));
 
+	unp = sotounpcb(so);
+	KASSERT(unp != NULL, ("uipc_connect: unp == NULL"));
 	UNP_LOCK();
-	unp = sotounpcb(so);
-	if (unp == NULL) {
-		UNP_UNLOCK();
-		return (EINVAL);
-	}
 	error = unp_connect(so, nam, td);
 	UNP_UNLOCK();
 	return (error);
@@ -240,12 +219,9 @@
 	struct unpcb *unp;
 	int error;
 
+	unp = sotounpcb(so1);
+	KASSERT(unp != NULL, ("uipc_connect2: unp == NULL"));
 	UNP_LOCK();
-	unp = sotounpcb(so1);
-	if (unp == NULL) {
-		UNP_UNLOCK();
-		return (EINVAL);
-	}
 	error = unp_connect2(so1, so2, PRU_CONNECT2);
 	UNP_UNLOCK();
 	return (error);
@@ -253,20 +229,16 @@
 
 /* control is EOPNOTSUPP */
 
-static int
+static void
 uipc_detach(struct socket *so)
 {
 	struct unpcb *unp;
 
+	unp = sotounpcb(so);
+	KASSERT(unp != NULL, ("uipc_detach: unp == NULL"));
 	UNP_LOCK();
-	unp = sotounpcb(so);
-	if (unp == NULL) {
-		UNP_UNLOCK();
-		return (EINVAL);
-	}
 	unp_detach(unp);
 	UNP_UNLOCK_ASSERT();
-	return (0);
 }
 
 static int
@@ -274,12 +246,9 @@
 {
 	struct unpcb *unp;
 
+	unp = sotounpcb(so);
+	KASSERT(unp != NULL, ("uipc_disconnect: unp == NULL"));
 	UNP_LOCK();
-	unp = sotounpcb(so);
-	if (unp == NULL) {
-		UNP_UNLOCK();
-		return (EINVAL);
-	}
 	unp_disconnect(unp);
 	UNP_UNLOCK();
 	return (0);
@@ -291,9 +260,10 @@
 	struct unpcb *unp;
 	int error;
 
+	unp = sotounpcb(so);
+	KASSERT(unp != NULL, ("uipc_listen: unp == NULL"));
 	UNP_LOCK();
-	unp = sotounpcb(so);
-	if (unp == NULL || unp->unp_vnode == NULL) {
+	if (unp->unp_vnode == NULL) {
 		UNP_UNLOCK();
 		return (EINVAL);
 	}
@@ -308,15 +278,10 @@
 	struct unpcb *unp;
 	const struct sockaddr *sa;
 
+	unp = sotounpcb(so);
+	KASSERT(unp != NULL, ("uipc_peeraddr: unp == NULL"));
 	*nam = malloc(sizeof(struct sockaddr_un), M_SONAME, M_WAITOK);
 	UNP_LOCK();
-	unp = sotounpcb(so);
-	if (unp == NULL) {
-		UNP_UNLOCK();
-		free(*nam, M_SONAME);
-		*nam = NULL;
-		return (EINVAL);
-	}
 	if (unp->unp_conn != NULL && unp->unp_conn->unp_addr!= NULL)
 		sa = (struct sockaddr *) unp->unp_conn->unp_addr;
 	else {
@@ -339,12 +304,9 @@
 	struct socket *so2;
 	u_long newhiwat;
 
+	unp = sotounpcb(so);
+	KASSERT(unp != NULL, ("uipc_rcvd: unp == NULL"));
 	UNP_LOCK();
-	unp = sotounpcb(so);
-	if (unp == NULL) {
-		UNP_UNLOCK();
-		return (EINVAL);
-	}
 	switch (so->so_type) {
 	case SOCK_DGRAM:
 		panic("uipc_rcvd DGRAM?");
@@ -390,10 +352,7 @@
 	u_long newhiwat;
 
 	unp = sotounpcb(so);
-	if (unp == NULL) {
-		error = EINVAL;
-		goto release;
-	}
+	KASSERT(unp != NULL, ("uipc_send: unp == NULL"));
 	if (flags & PRUS_OOB) {
 		error = EOPNOTSUPP;
 		goto release;
@@ -403,13 +362,6 @@
 		goto release;
 
 	UNP_LOCK();
-	unp = sotounpcb(so);
-	if (unp == NULL) {
-		UNP_UNLOCK();
-		error = EINVAL;
-		goto dispose_release;
-	}
-
 	switch (so->so_type) {
 	case SOCK_DGRAM:
 	{
@@ -523,7 +475,6 @@
 	}
 	UNP_UNLOCK();
 
-dispose_release:
 	if (control != NULL && error != 0)
 		unp_dispose(control);
 
@@ -541,12 +492,9 @@
 	struct unpcb *unp;
 	struct socket *so2;
 
+	unp = sotounpcb(so);
+	KASSERT(unp != NULL, ("uipc_sense: unp == NULL"));
 	UNP_LOCK();
-	unp = sotounpcb(so);
-	if (unp == NULL) {
-		UNP_UNLOCK();
-		return (EINVAL);
-	}
 	sb->st_blksize = so->so_snd.sb_hiwat;
 	if (so->so_type == SOCK_STREAM && unp->unp_conn != NULL) {
 		so2 = unp->unp_conn->unp_socket;
@@ -565,12 +513,9 @@
 {
 	struct unpcb *unp;
 
+	unp = sotounpcb(so);
+	KASSERT(unp != NULL, ("uipc_shutdown: unp == NULL"));
 	UNP_LOCK();
-	unp = sotounpcb(so);
-	if (unp == NULL) {
-		UNP_UNLOCK();
-		return (EINVAL);
-	}
 	socantsendmore(so);
 	unp_shutdown(unp);
 	UNP_UNLOCK();
@@ -583,15 +528,10 @@
 	struct unpcb *unp;
 	const struct sockaddr *sa;
 
+	unp = sotounpcb(so);
+	KASSERT(unp != NULL, ("uipc_sockaddr: unp == NULL"));
 	*nam = malloc(sizeof(struct sockaddr_un), M_SONAME, M_WAITOK);
 	UNP_LOCK();
-	unp = sotounpcb(so);
-	if (unp == NULL) {
-		UNP_UNLOCK();
-		free(*nam, M_SONAME);
-		*nam = NULL;
-		return (EINVAL);
-	}
 	if (unp->unp_addr != NULL)
 		sa = (struct sockaddr *) unp->unp_addr;
 	else
@@ -632,14 +572,10 @@
 	if (sopt->sopt_level != 0)
 		return (EINVAL);
 
+	unp = sotounpcb(so);
+	KASSERT(unp != NULL, ("uipc_ctloutput: unp == NULL"));
 	UNP_LOCK();
-	unp = sotounpcb(so);
-	if (unp == NULL) {
-		UNP_UNLOCK();
-		return (EINVAL);
-	}
 	error = 0;
-
 	switch (sopt->sopt_dir) {
 	case SOPT_GET:
 		switch (sopt->sopt_name) {
@@ -745,6 +681,8 @@
 	struct unpcb *unp;
 	int error;
 
+	KASSERT(so->so_pcb == NULL, ("unp_attach: so_pcb != NULL"));
+
 	if (so->so_snd.sb_hiwat == 0 || so->so_rcv.sb_hiwat == 0) {
 		switch (so->so_type) {
 
@@ -926,7 +864,9 @@
 	struct sockaddr *sa;
 
 	UNP_LOCK_ASSERT();
+
 	unp = sotounpcb(so);
+	KASSERT(unp != NULL, ("unp_connect: unp == NULL"));
 
 	len = nam->sa_len - offsetof(struct sockaddr_un, sun_path);
 	if (len <= 0)
@@ -956,10 +896,7 @@
 	mtx_unlock(&Giant);
 	UNP_LOCK();
 	unp = sotounpcb(so);
-	if (unp == NULL) {
-		error = EINVAL;
-		goto bad2;
-	}
+	KASSERT(unp != NULL, ("unp_connect: unp == NULL"));
 	so2 = vp->v_socket;
 	if (so2 == NULL) {
 		error = ECONNREFUSED;
@@ -1049,6 +986,7 @@
 	if (so2->so_type != so->so_type)
 		return (EPROTOTYPE);
 	unp2 = sotounpcb(so2);
+	KASSERT(unp2 != NULL, ("unp_connect2: unp2 == NULL"));
 	unp->unp_conn = unp2;
 	switch (so->so_type) {
 
--- net/raw_cb.c	2005/01/24 23:00:55
+++ net/raw_cb.c	2006/02/12 16:46:58
@@ -98,10 +98,9 @@
 {
 	struct socket *so = rp->rcb_socket;
 
-	ACCEPT_LOCK();
-	SOCK_LOCK(so);
-	so->so_pcb = 0;
-	sotryfree(so);
+	KASSERT(so->so_pcb == rp, ("raw_detach: so_pcb != rp"));
+
+	so->so_pcb = NULL;
 	mtx_lock(&rawcb_mtx);
 	LIST_REMOVE(rp, list);
 	mtx_unlock(&rawcb_mtx);
--- net/raw_usrreq.c	2005/01/07 01:52:23
+++ net/raw_usrreq.c	2006/02/19 18:36:12
@@ -138,19 +138,14 @@
 	/* INCOMPLETE */
 }
 
-static int
+static void
 raw_uabort(struct socket *so)
 {
 	struct rawcb *rp = sotorawcb(so);
 
-	if (rp == 0)
-		return EINVAL;
+	KASSERT(rp != NULL, ("raw_uabort: rp == NULL"));
 	raw_disconnect(rp);
 	soisdisconnected(so);
-	ACCEPT_LOCK();
-	SOCK_LOCK(so);
-	sotryfree(so);
-	return 0;
 }
 
 /* pru_accept is EOPNOTSUPP */
@@ -158,11 +153,9 @@
 static int
 raw_uattach(struct socket *so, int proto, struct thread *td)
 {
-	struct rawcb *rp = sotorawcb(so);
 	int error;
 
-	if (rp == 0)
-		return EINVAL;
+	KASSERT(sotorawcb(so) == NULL, ("raw_uattach: rp != NULL"));
 	if (td && (error = suser(td)) != 0)
 		return error;
 	return raw_attach(so, proto);
@@ -183,16 +176,13 @@
 /* pru_connect2 is EOPNOTSUPP */
 /* pru_control is EOPNOTSUPP */
 
-static int
+static void
 raw_udetach(struct socket *so)
 {
 	struct rawcb *rp = sotorawcb(so);
 
-	if (rp == 0)
-		return EINVAL;
-
+	KASSERT(rp != NULL, ("raw_udetach: rp == NULL"));
 	raw_detach(rp);
-	return 0;
 }
 
 static int
@@ -200,8 +190,7 @@
 {
 	struct rawcb *rp = sotorawcb(so);
 
-	if (rp == 0)
-		return EINVAL;
+	KASSERT(rp != NULL, ("raw_udisconnect: rp == NULL"));
 	if (rp->rcb_faddr == 0) {
 		return ENOTCONN;
 	}
@@ -217,8 +206,7 @@
 {
 	struct rawcb *rp = sotorawcb(so);
 
-	if (rp == 0)
-		return EINVAL;
+	KASSERT(rp != NULL, ("raw_upeeraddr: rp == NULL"));
 	if (rp->rcb_faddr == 0) {
 		return ENOTCONN;
 	}
@@ -236,10 +224,7 @@
 	int error;
 	struct rawcb *rp = sotorawcb(so);
 
-	if (rp == 0) {
-		error = EINVAL;
-		goto release;
-	}
+	KASSERT(rp != NULL, ("raw_usend: rp == NULL"));
 
 	if (flags & PRUS_OOB) {
 		error = EOPNOTSUPP;
@@ -275,10 +260,8 @@
 static int
 raw_ushutdown(struct socket *so)
 {
-	struct rawcb *rp = sotorawcb(so);
 
-	if (rp == 0)
-		return EINVAL;
+	KASSERT(sotorawcb(so) != NULL, ("raw_ushutdown: rp == NULL"));
 	socantsendmore(so);
 	return 0;
 }
@@ -288,8 +271,7 @@
 {
 	struct rawcb *rp = sotorawcb(so);
 
-	if (rp == 0)
-		return EINVAL;
+	KASSERT(rp != NULL, ("raw_usockaddr: rp == NULL"));
 	if (rp->rcb_laddr == 0)
 		return EINVAL;
 	*nam = sodupsockaddr(rp->rcb_laddr, M_WAITOK);
--- net/rtsock.c	2005/11/11 16:05:46
+++ net/rtsock.c	2006/02/13 21:56:55
@@ -137,11 +137,11 @@
  * It really doesn't make any sense at all for this code to share much
  * with raw_usrreq.c, since its functionality is so restricted.  XXX
  */
-static int
+static void
 rts_abort(struct socket *so)
 {
 
-	return (raw_usrreqs.pru_abort(so));
+	raw_usrreqs.pru_abort(so);
 }
 
 /* pru_accept is EOPNOTSUPP */
@@ -152,8 +152,8 @@
 	struct rawcb *rp;
 	int s, error;
 
-	if (sotorawcb(so) != NULL)
-		return EISCONN;	/* XXX panic? */
+	KASSERT(so->so_pcb == NULL, ("rts_attach: so_pcb != NULL"));
+
 	/* XXX */
 	MALLOC(rp, struct rawcb *, sizeof *rp, M_PCB, M_WAITOK | M_ZERO);
 	if (rp == NULL)
@@ -214,32 +214,28 @@
 /* pru_connect2 is EOPNOTSUPP */
 /* pru_control is EOPNOTSUPP */
 
-static int
+static void
 rts_detach(struct socket *so)
 {
 	struct rawcb *rp = sotorawcb(so);
-	int s, error;
+
+	KASSERT(rp != NULL, ("rts_detach: rp == NULL"));
 
-	s = splnet();
-	if (rp != NULL) {
-		RTSOCK_LOCK();
-		switch(rp->rcb_proto.sp_protocol) {
-		case AF_INET:
-			route_cb.ip_count--;
-			break;
-		case AF_INET6:
-			route_cb.ip6_count--;
-			break;
-		case AF_IPX:
-			route_cb.ipx_count--;
-			break;
-		}
-		route_cb.any_count--;
-		RTSOCK_UNLOCK();
+	RTSOCK_LOCK();
+	switch(rp->rcb_proto.sp_protocol) {
+	case AF_INET:
+		route_cb.ip_count--;
+		break;
+	case AF_INET6:
+		route_cb.ip6_count--;
+		break;
+	case AF_IPX:
+		route_cb.ipx_count--;
+		break;
 	}
-	error = raw_usrreqs.pru_detach(so);
-	splx(s);
-	return error;
+	route_cb.any_count--;
+	RTSOCK_UNLOCK();
+	raw_usrreqs.pru_detach(so);
 }
 
 static int
--- netatalk/ddp_pcb.c	2005/01/07 02:37:15
+++ netatalk/ddp_pcb.c	2006/02/12 17:21:38
@@ -304,10 +304,7 @@
     DDP_LOCK_ASSERT(ddp);
 
     soisdisconnected(so);
-    ACCEPT_LOCK();
-    SOCK_LOCK(so);
     so->so_pcb = NULL;
-    sotryfree(so);
 
     /* remove ddp from ddp_ports list */
     if (ddp->ddp_lsat.sat_port != ATADDR_ANYPORT &&
--- netatalk/ddp_usrreq.c	2005/02/18 10:57:04
+++ netatalk/ddp_usrreq.c	2006/02/15 20:26:05
@@ -56,8 +56,7 @@
 	int		error = 0;
 	
 	ddp = sotoddpcb(so);
-	if (ddp != NULL)
-		return (EINVAL);
+	KASSERT(ddp == NULL, ("ddp_attach: ddp != NULL"));
 
 	/*
 	 * Allocate socket buffer space first so that it's present
@@ -73,20 +72,18 @@
 	return (error);
 }
 
-static int
+static void
 ddp_detach(struct socket *so)
 {
 	struct ddpcb	*ddp;
 	
 	ddp = sotoddpcb(so);
-	if (ddp == NULL)
-	    return (EINVAL);
+	KASSERT(ddp != NULL, ("ddp_detach: ddp == NULL"));
 
 	DDP_LIST_XLOCK();
 	DDP_LOCK(ddp);
 	at_pcbdetach(so, ddp);
 	DDP_LIST_XUNLOCK();
-	return (0);
 }
 
 static int      
@@ -96,9 +93,8 @@
 	int		error = 0;
 	
 	ddp = sotoddpcb(so);
-	if (ddp == NULL) {
-	    return (EINVAL);
-	}
+	KASSERT(ddp != NULL, ("ddp_bind: ddp == NULL"));
+
 	DDP_LIST_XLOCK();
 	DDP_LOCK(ddp);
 	error = at_pcbsetaddr(ddp, nam, td);
@@ -114,9 +110,7 @@
 	int		error = 0;
 	
 	ddp = sotoddpcb(so);
-	if (ddp == NULL) {
-	    return (EINVAL);
-	}
+	KASSERT(ddp != NULL, ("ddp_connect: ddp == NULL"));
 
 	DDP_LIST_XLOCK();
 	DDP_LOCK(ddp);
@@ -141,9 +135,7 @@
 	struct ddpcb	*ddp;
 	
 	ddp = sotoddpcb(so);
-	if (ddp == NULL) {
-	    return (EINVAL);
-	}
+	KASSERT(ddp != NULL, ("ddp_disconnect: ddp == NULL"));
 	DDP_LOCK(ddp);
 	if (ddp->ddp_fsat.sat_addr.s_node == ATADDR_ANYNODE) {
 	    DDP_UNLOCK(ddp);
@@ -163,9 +155,7 @@
 	struct ddpcb	*ddp;
 
 	ddp = sotoddpcb(so);
-	if (ddp == NULL) {
-		return (EINVAL);
-	}
+	KASSERT(ddp != NULL, ("ddp_shutdown: ddp == NULL"));
 	socantsendmore(so);
 	return (0);
 }
@@ -178,9 +168,7 @@
 	int		error = 0;
 	
 	ddp = sotoddpcb(so);
-	if (ddp == NULL) {
-		return (EINVAL);
-	}
+	KASSERT(ddp != NULL, ("ddp_send: ddp == NULL"));
 
     	if (control && control->m_len) {
 		return (EINVAL);
@@ -213,20 +201,17 @@
 	return (error);
 }
 
-static int
+static void
 ddp_abort(struct socket *so)
 {
 	struct ddpcb	*ddp;
 	
 	ddp = sotoddpcb(so);
-	if (ddp == NULL) {
-		return (EINVAL);
-	}
+	KASSERT(ddp != NULL, ("ddp_abort: ddp == NULL"));
 	DDP_LIST_XLOCK();
 	DDP_LOCK(ddp);
 	at_pcbdetach(so, ddp);
 	DDP_LIST_XUNLOCK();
-	return (0);
 }
 
 void 
@@ -269,9 +254,7 @@
 	struct ddpcb	*ddp;
 
 	ddp = sotoddpcb(so);
-	if (ddp == NULL) {
-	    return (EINVAL);
-	}
+	KASSERT(ddp != NULL, ("at_setsockaddr: ddp == NULL"));
 	DDP_LOCK(ddp);
 	at_sockaddr(ddp, nam);
 	DDP_UNLOCK(ddp);
--- netatm/atm_aal5.c	2005/10/30 19:45:29
+++ netatm/atm_aal5.c	2006/02/15 20:28:21
@@ -66,7 +66,7 @@
  * Local functions
  */
 static int	atm_aal5_attach(struct socket *, int, struct thread *td);
-static int	atm_aal5_detach(struct socket *);
+static void	atm_aal5_detach(struct socket *);
 static int	atm_aal5_bind(struct socket *, struct sockaddr *, 
 			struct thread *td);
 static int	atm_aal5_listen(struct socket *, int backlog,
@@ -78,7 +78,7 @@
 static int	atm_aal5_shutdown(struct socket *);
 static int	atm_aal5_send(struct socket *, int, KBuffer *,
 			struct sockaddr *, KBuffer *, struct thread *td);
-static int	atm_aal5_abort(struct socket *);
+static void	atm_aal5_abort(struct socket *);
 static int	atm_aal5_control(struct socket *, u_long, caddr_t, 
 			struct ifnet *, struct thread *td);
 static int	atm_aal5_sense(struct socket *, struct stat *);
@@ -204,6 +204,11 @@
 	;
 #endif /* DIAGNOSTIC */
 
+#define	ATM_INTRO_NOERR(f)					\
+	int		s;					\
+	s = splnet();						\
+	;
+
 #define	ATM_OUTRO()						\
 	/*							\
 	 * Drain any deferred calls				\
@@ -213,6 +218,14 @@
 	return (err);						\
 	;
 
+#define	ATM_OUTRO_NOERR()					\
+	/*							\
+	 * Drain any deferred calls				\
+	 */							\
+	STACK_DRAIN();						\
+	(void) splx(s);						\
+	;
+
 #define	ATM_RETERR(errno) {					\
 	err = errno;						\
 	goto out;						\
@@ -277,15 +290,15 @@
  *	errno	error processing request - reason indicated
  *
  */
-static int
+static void
 atm_aal5_detach(so)
 	struct socket	*so;
 {
-	ATM_INTRO("detach");
+	ATM_INTRO_NOERR("detach");
 
-	err = atm_sock_detach(so);
+	atm_sock_detach(so);
 
-	ATM_OUTRO();
+	ATM_OUTRO_NOERR();
 }
 
 
@@ -546,16 +559,16 @@
  *	errno	error processing request - reason indicated
  *
  */
-static int
+static void
 atm_aal5_abort(so)
 	struct socket	*so;
 {
-	ATM_INTRO("abort");
+	ATM_INTRO_NOERR("abort");
 
 	so->so_error = ECONNABORTED;
-	err = atm_sock_detach(so);
+	atm_sock_detach(so);
 
-	ATM_OUTRO();
+	ATM_OUTRO_NOERR();
 }
 
 
--- netatm/atm_proto.c	2005/11/09 13:31:29
+++ netatm/atm_proto.c	2006/02/12 18:36:34
@@ -184,3 +184,17 @@
 {
 	return (EOPNOTSUPP);
 }
+
+/*
+ * Protocol request not supported
+ *
+ * Arguments:
+ *	so	pointer to socket
+ *
+ */
+void
+atm_proto_notsupp5(so)
+	struct socket	*so;
+{
+
+}
--- netatm/atm_socket.c	2005/10/30 19:45:29
+++ netatm/atm_socket.c	2006/02/12 18:36:34
@@ -146,12 +146,8 @@
  * Arguments:
  *	so	pointer to socket
  *
- * Returns:
- *	0	detach successful
- *	errno	detach failed - reason indicated
- *
  */
-int
+void
 atm_sock_detach(so)
 	struct socket	*so;
 {
@@ -160,8 +156,7 @@
 	/*
 	 * Make sure we're still attached
 	 */
-	if (atp == NULL)
-		return (ENOTCONN);
+	KASSERT(atp != NULL, ("atm_sock_detach: atp == NULL"));
 
 	/*
 	 * Terminate any (possibly pending) connection
@@ -170,17 +165,9 @@
 		(void) atm_sock_disconnect(so);
 	}
 
-	/*
-	 * Break links and free control blocks
-	 */
-	ACCEPT_LOCK();
-	SOCK_LOCK(so);
 	so->so_pcb = NULL;
-	sotryfree(so);
 
 	uma_zfree(atm_pcb_zone, atp);
-
-	return (0);
 }
 
 
--- netatm/atm_usrreq.c	2005/06/10 16:51:34
+++ netatm/atm_usrreq.c	2006/02/15 20:28:21
@@ -66,11 +66,11 @@
  * New-style socket request routines
  */
 struct pr_usrreqs	atm_dgram_usrreqs = {
-	.pru_abort =		atm_proto_notsupp1,
+	.pru_abort =		atm_proto_notsupp5,
 	.pru_attach =		atm_dgram_attach,
 	.pru_bind =		atm_proto_notsupp2,
 	.pru_control =		atm_dgram_control,
-	.pru_detach =		atm_proto_notsupp1,
+	.pru_detach =		atm_proto_notsupp5,
 	.pru_disconnect =	atm_proto_notsupp1,
 	.pru_peeraddr =		atm_proto_notsupp3,
 	.pru_send =		atm_proto_notsupp4,
--- netatm/atm_var.h	2005/10/30 19:45:29
+++ netatm/atm_var.h	2006/02/12 18:36:34
@@ -136,6 +136,7 @@
 int		atm_proto_notsupp3(struct socket *, struct sockaddr **);
 int		atm_proto_notsupp4(struct socket *, int, KBuffer *, 
 			struct sockaddr *, KBuffer *, struct thread *);
+void		atm_proto_notsupp5(struct socket *);
 
 	/* atm_signal.c */
 int		atm_sigmgr_register(struct sigmgr *);
@@ -150,7 +151,7 @@
 	/* atm_socket.c */
 void		atm_sock_init(void);
 int		atm_sock_attach(struct socket *, u_long, u_long);
-int		atm_sock_detach(struct socket *);
+void		atm_sock_detach(struct socket *);
 int		atm_sock_bind(struct socket *, struct sockaddr *);
 int		atm_sock_listen(struct socket *, Atm_endpoint *, int);
 int		atm_sock_connect(struct socket *, struct sockaddr *,
--- netgraph/bluetooth/include/ng_btsocket_hci_raw.h	2005/01/07 01:52:23
+++ netgraph/bluetooth/include/ng_btsocket_hci_raw.h	2006/02/14 02:16:05
@@ -66,7 +66,7 @@
 #ifdef _KERNEL
 
 void ng_btsocket_hci_raw_init       (void);
-int  ng_btsocket_hci_raw_abort      (struct socket *);
+void ng_btsocket_hci_raw_abort      (struct socket *);
 int  ng_btsocket_hci_raw_attach     (struct socket *, int, struct thread *);
 int  ng_btsocket_hci_raw_bind       (struct socket *, struct sockaddr *, 
                                      struct thread *);
@@ -75,7 +75,7 @@
 int  ng_btsocket_hci_raw_control    (struct socket *, u_long, caddr_t,
                                      struct ifnet *, struct thread *);
 int  ng_btsocket_hci_raw_ctloutput  (struct socket *, struct sockopt *);
-int  ng_btsocket_hci_raw_detach     (struct socket *);
+void ng_btsocket_hci_raw_detach     (struct socket *);
 int  ng_btsocket_hci_raw_disconnect (struct socket *);
 int  ng_btsocket_hci_raw_peeraddr   (struct socket *, struct sockaddr **);
 int  ng_btsocket_hci_raw_send       (struct socket *, int, struct mbuf *,
--- netgraph/bluetooth/include/ng_btsocket_l2cap.h	2005/10/30 19:45:29
+++ netgraph/bluetooth/include/ng_btsocket_l2cap.h	2006/02/14 02:16:05
@@ -92,7 +92,7 @@
 #ifdef _KERNEL
 
 void ng_btsocket_l2cap_raw_init       (void);
-int  ng_btsocket_l2cap_raw_abort      (struct socket *);
+void ng_btsocket_l2cap_raw_abort      (struct socket *);
 int  ng_btsocket_l2cap_raw_attach     (struct socket *, int, struct thread *);
 int  ng_btsocket_l2cap_raw_bind       (struct socket *, struct sockaddr *,
                                        struct thread *);
@@ -100,7 +100,7 @@
                                        struct thread *);
 int  ng_btsocket_l2cap_raw_control    (struct socket *, u_long, caddr_t,
                                        struct ifnet *, struct thread *);
-int  ng_btsocket_l2cap_raw_detach     (struct socket *);
+void ng_btsocket_l2cap_raw_detach     (struct socket *);
 int  ng_btsocket_l2cap_raw_disconnect (struct socket *);
 int  ng_btsocket_l2cap_raw_peeraddr   (struct socket *, struct sockaddr **);
 int  ng_btsocket_l2cap_raw_send       (struct socket *, int, struct mbuf *,
@@ -183,7 +183,7 @@
 #ifdef _KERNEL
 
 void ng_btsocket_l2cap_init       (void);
-int  ng_btsocket_l2cap_abort      (struct socket *);
+void ng_btsocket_l2cap_abort      (struct socket *);
 int  ng_btsocket_l2cap_accept     (struct socket *, struct sockaddr **);
 int  ng_btsocket_l2cap_attach     (struct socket *, int, struct thread *);
 int  ng_btsocket_l2cap_bind       (struct socket *, struct sockaddr *,
@@ -193,7 +193,7 @@
 int  ng_btsocket_l2cap_control    (struct socket *, u_long, caddr_t,
                                    struct ifnet *, struct thread *);
 int  ng_btsocket_l2cap_ctloutput  (struct socket *, struct sockopt *);
-int  ng_btsocket_l2cap_detach     (struct socket *);
+void ng_btsocket_l2cap_detach     (struct socket *);
 int  ng_btsocket_l2cap_disconnect (struct socket *);
 int  ng_btsocket_l2cap_listen     (struct socket *, int, struct thread *);
 int  ng_btsocket_l2cap_peeraddr   (struct socket *, struct sockaddr **);
--- netgraph/bluetooth/include/ng_btsocket_rfcomm.h	2005/10/30 19:45:29
+++ netgraph/bluetooth/include/ng_btsocket_rfcomm.h	2006/02/14 02:16:05
@@ -314,7 +314,7 @@
 #ifdef _KERNEL
 
 void ng_btsocket_rfcomm_init       (void);
-int  ng_btsocket_rfcomm_abort      (struct socket *);
+void ng_btsocket_rfcomm_abort      (struct socket *);
 int  ng_btsocket_rfcomm_accept     (struct socket *, struct sockaddr **);
 int  ng_btsocket_rfcomm_attach     (struct socket *, int, struct thread *);
 int  ng_btsocket_rfcomm_bind       (struct socket *, struct sockaddr *,
@@ -324,7 +324,7 @@
 int  ng_btsocket_rfcomm_control    (struct socket *, u_long, caddr_t,
                                     struct ifnet *, struct thread *);
 int  ng_btsocket_rfcomm_ctloutput  (struct socket *, struct sockopt *);
-int  ng_btsocket_rfcomm_detach     (struct socket *);
+void ng_btsocket_rfcomm_detach     (struct socket *);
 int  ng_btsocket_rfcomm_disconnect (struct socket *);
 int  ng_btsocket_rfcomm_listen     (struct socket *, int, struct thread *);
 int  ng_btsocket_rfcomm_peeraddr   (struct socket *, struct sockaddr **);
--- netgraph/bluetooth/socket/ng_btsocket_hci_raw.c	2005/07/28 17:45:20
+++ netgraph/bluetooth/socket/ng_btsocket_hci_raw.c	2006/02/14 02:16:05
@@ -872,10 +872,10 @@
  * Abort connection on socket
  */
 
-int
+void
 ng_btsocket_hci_raw_abort(struct socket *so)
 {
-	return (ng_btsocket_hci_raw_detach(so));
+	ng_btsocket_hci_raw_detach(so);
 } /* ng_btsocket_hci_raw_abort */
 
 /*
@@ -1399,15 +1399,15 @@
  * Detach raw HCI socket
  */
 
-int
+void
 ng_btsocket_hci_raw_detach(struct socket *so)
 {
 	ng_btsocket_hci_raw_pcb_p	pcb = so2hci_raw_pcb(so);
 
-	if (pcb == NULL)
-		return (EINVAL);
+	KASSERT(pcb != NULL, ("ng_btsocket_hci_raw_detach: pcb == NULL"));
+
 	if (ng_btsocket_hci_raw_node == NULL)
-		return (EINVAL);
+		return;
 
 	mtx_lock(&ng_btsocket_hci_raw_sockets_mtx);
 	mtx_lock(&pcb->pcb_mtx);
@@ -1422,12 +1422,7 @@
 	bzero(pcb, sizeof(*pcb));
 	FREE(pcb, M_NETGRAPH_BTSOCKET_HCI_RAW);
 
-	ACCEPT_LOCK();
-	SOCK_LOCK(so);
 	so->so_pcb = NULL;
-	sotryfree(so);
-
-	return (0);
 } /* ng_btsocket_hci_raw_detach */
 
 /*
--- netgraph/bluetooth/socket/ng_btsocket_l2cap.c	2005/10/30 19:45:29
+++ netgraph/bluetooth/socket/ng_btsocket_l2cap.c	2006/02/14 02:16:05
@@ -1912,12 +1912,12 @@
  * Abort connection on socket
  */
 
-int
+void
 ng_btsocket_l2cap_abort(struct socket *so)
 {
 	so->so_error = ECONNABORTED;
 
-	return (ng_btsocket_l2cap_detach(so));
+	ng_btsocket_l2cap_detach(so);
 } /* ng_btsocket_l2cap_abort */
 
 /*
@@ -2316,15 +2316,15 @@
  * Detach and destroy socket
  */
 
-int
+void
 ng_btsocket_l2cap_detach(struct socket *so)
 {
 	ng_btsocket_l2cap_pcb_p	pcb = so2l2cap_pcb(so);
 
-	if (pcb == NULL)
-		return (EINVAL);
+	KASSERT(pcb != NULL, ("ng_btsocket_l2cap_detach: pcb == NULL"));
+
 	if (ng_btsocket_l2cap_node == NULL) 
-		return (EINVAL);
+		return;
 
 	mtx_lock(&ng_btsocket_l2cap_sockets_mtx);
 	mtx_lock(&pcb->pcb_mtx);
@@ -2350,12 +2350,7 @@
 	FREE(pcb, M_NETGRAPH_BTSOCKET_L2CAP);
 
 	soisdisconnected(so);
-	ACCEPT_LOCK();
-	SOCK_LOCK(so);
 	so->so_pcb = NULL;
-	sotryfree(so);
-
-	return (0);
 } /* ng_btsocket_l2cap_detach */
 
 /*
